package ast;

import java.util.ArrayList;

import org.antlr.runtime.Token;

import terminais.Identificador;



import framework.IVisitor;

public class Programa extends Node {

	public Programa(Token payload) {
		super(payload);
	}
			
	@Override
	public Object accept(IVisitor visitor, Object o) {
		return visitor.visit(this, o);
	}	
	
	// ID
	public Identificador getID() {
		return (Identificador) this.getChild(0);
	}
	
	//Declaracoes
	public ArrayList<Declaracao> getDeclaracoes() {
		ArrayList<Declaracao> result = new ArrayList<Declaracao>();
		int i = 0;
		for (Object node : getChildren()) {
			
			try{
				Declaracao  cla = (Declaracao) node;
				result.add(cla);
			
			}catch (Exception e){
				
				i++;
			}
			
		}
		
		return result;
	}
	
	public ArrayList<Funcao> getFuncoes(){
		ArrayList<Funcao> result = new ArrayList<Funcao>();
		int i = 0;
		for (Object node : getChildren()) {
			
			try{
				Funcao  cla = (Funcao) node;
				result.add(cla);
			
			}catch (Exception e){				
				i++;
			}
			
		}
		
		return result;
	}
	
	public ArrayList<Instrucoes> getInstrucoes() {
		ArrayList<Instrucoes> result = new ArrayList<Instrucoes>();
		int i = 0;
		for (Object node : getChildren()) {
			
			try{
				Instrucoes  instr = (Instrucoes) node;
				result.add(instr);
			
			}catch (Exception e){
				//System.out.println("isso ta escroto demais["+i+"] -- ast.Classe");
				i++;
			}
			
		}
		
		return result;
	}
	
	//sub ok
	//while
	//until
	//for 
	
	public ArrayList<Sub> getSub(){
		ArrayList<Sub> result = new ArrayList<Sub>();
		int i = 0;
		for (Object node : getChildren()) {			
			try{
				Sub  cla = (Sub) node;
				result.add(cla);
			
			}catch (Exception e){				
				i++;
			}			
		}		
		return result;
	} 
	
	public ArrayList<InstrucaoWhile> getInstrucaoWhile(){
		ArrayList<InstrucaoWhile> result = new ArrayList<InstrucaoWhile>();
		int i = 0;
		for (Object node : getChildren()) {			
			try{
				InstrucaoWhile  instr = (InstrucaoWhile) node;
				result.add(instr);
			
			}catch (Exception e){				
				i++;
			}			
		}		
		return result;
	} 
	
	public ArrayList<InstrucaoUntil> getInstrucaoUntil(){
		ArrayList<InstrucaoUntil> result = new ArrayList<InstrucaoUntil>();
		int i = 0;
		for (Object node : getChildren()) {			
			try{
				InstrucaoUntil  instr = (InstrucaoUntil) node;
				result.add(instr);
			
			}catch (Exception e){				
				i++;
			}			
		}		
		return result;
	}
	
	public ArrayList<InstrucaoFor> getInstrucaoFor(){
		ArrayList<InstrucaoFor> result = new ArrayList<InstrucaoFor>();
		int i = 0;
		for (Object node : getChildren()) {			
			try{
				InstrucaoFor  instr = (InstrucaoFor) node;
				result.add(instr);
			
			}catch (Exception e){				
				i++;
			}			
		}		
		return result;
	}
	
	
	
}
