package ast;

import java.util.ArrayList;
import org.antlr.runtime.Token;
import framework.IVisitor;

public class TermoNumerico extends Node{

	public TermoNumerico(Token payload) {
		super(payload);
	}
	
	
	public OperadorTermoNumerico getOperadorTermoNumerico() {
		return (OperadorTermoNumerico) getChild(1);
	}
	
	
	public ArrayList<ArrayList<Object>> getFilhos() {

		ArrayList<ArrayList<Object>> operadores = new ArrayList<ArrayList<Object>>();
		int i = 0;
		boolean primVez = true;
		for (Object node : getChildren()) {

			try{
				ArrayList<Object> filhos = new ArrayList<Object>();
				OperadorTermoNumerico op = (OperadorTermoNumerico) node;
				filhos.add(op);
				operadores.add(filhos);
			}catch (Exception e){
				if(primVez){
					primVez = false;
				}else{
					ArrayList<Object> expressoes = operadores.get(i);
					FatorNumerico exp = (FatorNumerico) node;				
					expressoes.add(exp);							
					i++;
				}
			}
		}

		return operadores;
	}
	
	@Override
	public Object accept(IVisitor visitor, Object o) {	
		return visitor.visit(this, o);
	}


	public FatorNumerico getFatorNumerico() {
		return (FatorNumerico) getChild(0);
	}
	
	

}
