package ast;

import org.antlr.runtime.Token;

import terminais.TiposPrimitivos;
import framework.IVisitor;

public class Tipo extends Node {
	
	public Tipo(Token payload) {
		super(payload);
	}

	public TiposPrimitivos getTipo(){

		TiposPrimitivos retorno = TiposPrimitivos.Unknow;		
		String tipo = this.getChild(0).getText();		

		if(tipo.toLowerCase().equals("integer")){
			retorno = TiposPrimitivos.Integer;
		}else if(tipo.toLowerCase().equals("boolean")){
			retorno = TiposPrimitivos.Boolean;
		}else if(tipo.toLowerCase().equals("string")){
			retorno = TiposPrimitivos.String;
		}

		return retorno;		
	}

	public boolean isBoolean(){
		if(this.getText().toLowerCase().equals("boolean")){
			return true;
		}else return false;
	}

	public boolean isInt(){
		if(this.getText().toLowerCase().equals("integer")){
			return true;
		}else return false;
	}
	
	public boolean isString(){
		if(this.getText().toLowerCase().equals("string")){
			return true;
		}else return false;
	}
	@Override
	public Object accept(IVisitor visitor, Object o) {
		return visitor.visit(this, o);
	}

}
