package framework;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import antlr.GramaticaParser.listaParametros_return;
import ast.ListaParamentros;

import terminais.Identificador;
import terminais.TiposPrimitivos;


public class CompilationEnvironment {

	private Map<String, TiposPrimitivos> mapping;
	private Map<String, Integer> pilha;
	private Map<String, ListaParamentros> parametros;
	
	
	public CompilationEnvironment() {
		this.mapping = new HashMap<String, TiposPrimitivos>();
		this.pilha = new HashMap<String, Integer>();
		this.parametros = new HashMap<String, ListaParamentros>();
	}

	public void clear() {
		mapping.clear();
	}
	
	public void clearParametros(){
		parametros.clear();
	}
	
	public boolean containsIdentifier(Identificador identifier) {
		return mapping.containsKey(identifier.getText().toLowerCase());
	}

	public boolean containsMetodo(Identificador id){
		return parametros.containsKey(id.getText().toLowerCase());
	}
	
	public void addIdentificador(Identificador Identificador, TiposPrimitivos typeDenoter) {		
		mapping.put(Identificador.getText().toLowerCase(), typeDenoter);		
	}
	
	public void addMetodo(Identificador id, ListaParamentros par){
		parametros.put(id.getText().toLowerCase(), par);
	}

	public TiposPrimitivos getTipoID(Identificador id){
		return mapping.get(id.getText().toLowerCase());
	}
	
	public ListaParamentros getListaParametros(Identificador id){
		return parametros.get(id.getText().toLowerCase());
	}
		
	public void addNaPilha(Identificador identificador, int i){
		this.pilha.put(identificador.getText().toLowerCase(), i);
	}
	public int getIndiceVariavel(Identificador identificador){
		return this.pilha.get(identificador.getText().toLowerCase());
	}
	
}
