package framework;

import java.util.Map;

import terminais.BooleanType;
import terminais.Identificador;
import terminais.IntegerType;
import terminais.StringType;
import terminais.TiposPrimitivos;
import ast.Atribuicao;
import ast.Bloco_Else;
import ast.Bloco_If;
import ast.Chamada;
import ast.Comparacao;
import ast.Constante;
import ast.Declaracao;
import ast.Expressao;
import ast.ExpressaoUnaria;
import ast.Expression;
import ast.FatorBooleano;
import ast.FatorNumerico;
import ast.Funcao;
import ast.Inequacao;
import ast.InstrucaoFor;
import ast.InstrucaoIf;
import ast.InstrucaoInput;
import ast.InstrucaoPrint;
import ast.InstrucaoUntil;
import ast.InstrucaoWhile;
import ast.Instrucoes;
import ast.ListaExpressoes;
import ast.ListaParamentros;
import ast.ListaVariavel;
import ast.OperadoresComparacao;
import ast.OperadorFatorNumerico;
import ast.OperadoresInequacao;
import ast.OperadorTermoNumerico;
import ast.Programa;
import ast.Sub;
import ast.TermoNumerico;
import ast.Tipo;
import ast.Unidade;
import ast.Variavel;


public interface IVisitor {

	Object visit(Programa program, Object obj);		
	
	Object visit(StringType stringType, Object obj);
	
	Object visit(IntegerType intergerType, Object obj);
	
	Object visit(Identificador identificador, Object obj);

	Object visit(ListaVariavel listaVariavel, Object obj);

	Object visit(Tipo tipo, Object o);

	Object visit(BooleanType booleanType, Object obj);

	Object visit(Bloco_If bloco_If, Object obj);

	Object visit(InstrucaoFor instrucaoFor, Object obj);

	Object visit(Instrucoes instrucoes, Object obj);

	Object visit(Bloco_Else bloco_Else, Object obj);

	Object visit(InstrucaoIf instrucaoIf, Object obj);

	Object visit(Expressao expressao, Object o);

	Object visit(FatorBooleano fatorBooleano, Object o);

	Object visit(Comparacao comparacao, Object o);

	Object visit(Inequacao inequacao, Object o);

	Object visit(TermoNumerico termoNumerico, Object o);

	Object visit(OperadoresComparacao operadorComparacao, Object o);

	Object visit(FatorNumerico fatorNumerico, Object o);

	Object visit(ExpressaoUnaria expressaoUnaria, Object o);

	Object visit(OperadorFatorNumerico operadorFatorNumerico, Object o);

	Object visit(OperadoresInequacao operadorInequacao, Object o);

	Object visit(OperadorTermoNumerico operadorTermoNumerico, Object o);

	Object visit(Unidade unidade, Object o);

	Object visit(Constante constante, Object o);

	Object visit(InstrucaoWhile instrucaoWhile, Object o);

	Object visit(InstrucaoUntil instrucaoUntil, Object o);

	Object visit(ListaParamentros listaParamentros, Object o);

	Object visit(Funcao funcao, Object o);

	Object visit(Sub sub, Object o);

	Object visit(InstrucaoInput instrucaoInput, Object o);

	Object visit(InstrucaoPrint instrucaoPrint, Object o);

	Object visit(ListaExpressoes listaExpressoes, Object obj);

	Object visit(Chamada chamada, Object obj);

	Object visit(Variavel variavel, Object o);
	
	Object visit(Declaracao declaracao, Object obj);

	Object visit(Expression expression, Object obj);

	Object visit(Atribuicao atribuicao, Object obj);

	
	

}
