package main;

import java.io.IOException;



import org.antlr.runtime.ANTLRFileStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.RecognitionException;

import framework.ConsoleErrorReporter;



import adaptors.GramaticaTreeAdaptor;

import antlr.GramaticaChecker;
import antlr.GramaticaLexer;
import antlr.GramaticaParser;
import ast.Programa;


public class Main {

	public static void main(String[] args) {

		try {
			GramaticaLexer lex = new GramaticaLexer(new ANTLRFileStream("entrada.lb"));
			CommonTokenStream tokens = new CommonTokenStream(lex);			

			GramaticaParser parser = new GramaticaParser(tokens);
			parser.setTreeAdaptor(new GramaticaTreeAdaptor());
			
			Programa program = (Programa) parser.programa().getTree();			

			//anlise semntica
			ConsoleErrorReporter erros = new ConsoleErrorReporter();
			GramaticaChecker checker = new GramaticaChecker(erros);
			checker.visit(program, null);	
			
			/*
            if (erros.getNumeroDeErros() == 0) {
            	System.out.println("Compilation succeeded!");


           // geracao de codigo 
            	System.out.println("Code generation..");

            	AulaCodeGenerator codeGenerator = new AulaCodeGenerator(checker);
            	codeGenerator.visit(programa, null);

            	System.out.println("Code generation done\n");
            }
            /*
            else {
            	System.out.printf("Compilation failed with %d error(s)!", errorReporter.getNumberOfErrors());
            } */
		} catch (IOException e) { 
			System.out.println("entrou erro 1");
			e.printStackTrace();
		} catch (RecognitionException e) {
			System.out.println("entrou erro 2");
			e.printStackTrace();
		}
	}
}
